SystemOrganization addCategory: #'DAO-SatelliteUI'!

WAComponent subclass: #CommandRequestUI
	instanceVariableNames: 'subsystems commandRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/24/2013 19:33'!
chooseCommand: aCommandList

	| commandView |
	commandView := CommandsView newWithCommands: aCommandList andRequest: self commandRequest.
	self call:( commandView ) ! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/23/2013 16:31'!
commandRequest
	^ commandRequest ifNil: [commandRequest := CommandRequest new].! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/24/2013 21:15'!
initialize

	| satelite |
	super initialize.
	satelite := SatelliteTest satelliteWithAllSubsystems.
	subsystems := satelite subsystems! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 19:06'!
renderContentOn: html
	|commands names|
	
	names := subsystems collect: [:aSubsystem | aSubsystem name ].
	commands := Dictionary new.
	subsystems do: [ :sub | commands addAll: sub commands].
	
	
        html text: 'Subsystem: '.
        html select 
            list: names ;
           selected: 'Elija subsistema';
            callback: [ :value | |cmd|
				cmd := subsystems select: [ :each | each name = value ].
				self commandRequest subsystemId: cmd id.
				commands:= commands select: [ :ea | (cmd commands) includes: ea]
				].
		html anchor
                callback: [ self chooseCommand: commands ];
                with: 'choose command'.

	
! !

WAComponent subclass: #CommandsView
	instanceVariableNames: 'commandList commandRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandsView class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/23/2013 22:44'!
newWithCommands: commands andRequest: request

	^self new initializeWithCommands: commands andRequest: request
	! !

!CommandsView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/24/2013 18:30'!
commandRequest
	^commandRequest ! !

!CommandsView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/23/2013 22:54'!
initializeWithCommands: commands andRequest: request
	super initialize.
	commandList := commands.
	commandRequest := request ! !

!CommandsView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 19:48'!
renderContentOn: html
	|  commandNames |
	commandNames:= commandList keys.
	
	html space.
	        html text: 'Command: '.
        html select 
            list: commandNames;
           selected: 'Elija comando';
            callback: [ :value | |cmd|
				cmd := commandList at: value.
				self commandRequest commandId: cmd id.
				].

	html submitButton
	callback: [ self answer: self commandRequest ];
	value: 'Send'.! !

WAComponent subclass: #DAOSatelliteControllerLauncher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/21/2013 21:39'!
shutDown

	ZnZincServerAdaptor stop 

! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:46'!
startApp

	ZnZincServerAdaptor startOn: 8080.
	WAAdmin register: CommandRequestUI asApplicationAt: 'DAOSatelliteUI'.
	 WAAdmin register: ToDoHandler at: 'todo-api'.
	WAAdmin register: ToDoListView  asApplicationAt: 'todo'

! !

WAComponent subclass: #ToDoListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 19:38'!
add
    self model add: (ToDoItem new)! !

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 19:07'!
edit: anItem
    self inform: anItem title! !

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:47'!
model
    ^ ToDoList default! !

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 19:09'!
remove: anItem
    (self confirm: 'Are you sure you want to remove ' , anItem title printString , '?')
        ifTrue: [ self model remove: anItem ]! !

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:59'!
renderContentOn: html
	self style.
    html text: self model title.
	html unorderedList: [ self renderItemsOn: html ]
	! !

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 19:00'!
renderItem: anItem on: html
    html listItem
        class: 'done' if: anItem isDone;
        class: 'overdue' if: anItem isOverdue;
        with: [
            html text: anItem title.
            html space.
            html anchor
                callback: [ self edit: anItem ];
                with: 'edit'.
            html space.
            html anchor
                callback: [ self remove: anItem ];
                with: 'remove' ]! !

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:54'!
renderItemsOn: html
    self model items
        do: [ :each | self renderItem: each on: html ]
	! !

!ToDoListView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:57'!
style
    ^ 'body {
    color: #222;
    font-size: 75%;
    font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
}
h1 {
    color: #111;
    font-size: 2em;
    font-weight: normal;
    margin-bottom: 0.5em;
}
ul {
    list-style: none;
    padding-left: 0;
    margin-bottom: 1em;
}
li.overdue {
    color: #8a1f11;
}
li.done {
    color: #264409;
}'! !

WARestfulHandler subclass: #ToDoHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ToDoHandler methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:09'!
list

	<get>
	
	^	String streamContents: [ : stream |	 ToDoList default items do: [ :each | stream nextPutAll: each title; crlf ] ]! !

Object subclass: #ToDoItem
	instanceVariableNames: 'title due done'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:14'!
done
	^done! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:15'!
done: aBoolean
	done := aBoolean ! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:14'!
due
	^due! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:14'!
due: aDate 
	due := aDate asDate! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:16'!
initialize
    self title: 'ToDo Item'.
    self due: Date tomorrow.
    self done: false.! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:16'!
isDone
	^self done! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:17'!
isOverdue
	^self isDone not and: [ Date today > self due ]! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:13'!
title
	^title! !

!ToDoItem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:13'!
title: aString
	title := aString! !

Object subclass: #ToDoList
	instanceVariableNames: 'title items'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ToDoList class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:20'!
default
    ^ Default ifNil: [ Default := self new ]! !

!ToDoList class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:21'!
initializeExamples
    "self initializeExamples"

    self default
        title: 'Seaside ToDo';
        add: (ToDoItem new
            title: 'Finish todo app chapter';
            due: '11/15/2007' asDate;
            done: false);
        add: (ToDoItem new
            title: 'Annotate first chapter';
            due: '04/21/2008' asDate;
            done: true);
         add: (ToDoItem new
            title: 'Watch out for UNIX Millenium bug';
            due: '01/19/2038' asDate;
            done: false)! !

!ToDoList class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:21'!
reset
   Default := nil! !

!ToDoList methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:20'!
add: aTodoItem
    self items add: aTodoItem! !

!ToDoList methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:19'!
initialize
    self items: OrderedCollection new! !

!ToDoList methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:19'!
items
	^items! !

!ToDoList methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:31'!
items: anOrderedCollection 
	
	items := anOrderedCollection! !

!ToDoList methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:20'!
remove: aTodoItem
    self items remove: aTodoItem! !

!ToDoList methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:19'!
title
	^title! !

!ToDoList methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/25/2013 18:32'!
title: aByteString 

	title := aByteString! !
